<html lang="en">
<head>
<title>ESS --- Emacs Speaks Statistics</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="ESS --- Emacs Speaks Statistics">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="top" href="#Top">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p><hr>
<a name="General-Information"></a>
Previous:&nbsp;<a rel="previous" accesskey="p" href="#dir">(dir)</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#dir">(dir)</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">1 General Information: README</h2>

<p><a name="index-README-1"></a>
This is the README file for the distribution of ESS version

   <p>5.3.7

   <p>ESS is a GNU Emacs and XEmacs mode for interactive statistical programming
and data analysis.  Languages supported: the S family (S 3/4, S-PLUS
3/4/5/6/7, and R), SAS, XLispStat, Stata and BUGS.  Installation help can
be found in sections for both Unix and Windows.  ESS grew out of the desire
for bug fixes and extensions to S-mode and SAS-mode as well as a consistent
union of their features in one package.

   <p>The current development team is led by Martin Maechler since August
2004. Former project leader A.J. (Tony) Rossini
(<a href="mailto:rossini@blindglobe.net">rossini@blindglobe.net</a>) did the initial port to
XEmacs and has been the primary coder.  Martin Maechler
(<a href="mailto:maechler@stat.math.ethz.ch">maechler@stat.math.ethz.ch</a>) and Kurt Hornik
(<a href="mailto:Kurt.Hornik@R-project.org">Kurt.Hornik@R-project.org</a>) have assisted with S-PLUS, S4, R, and
XLispStat.  Stephen Eglen (<a href="mailto:stephen@gnu.org">stephen@gnu.org</a>) has worked mostly
on R support.  Richard M. Heiberger (<a href="mailto:rmh@temple.edu">rmh@temple.edu</a>) has
assisted with S-PLUS and S4 development for Windows.  Richard and
Rodney A. Sparapani (<a href="mailto:rsparapa@mcw.edu">rsparapa@mcw.edu</a>) have done much of the work
implementing interactive SAS (i<acronym>ESS[SAS]</acronym><!-- /@w -->) and batch SAS (<acronym>ESS[SAS]</acronym>) support.

   <p>We are grateful to the previous developers of S-mode (Doug Bates, Ed Kademan,
Frank Ritter, David M. Smith), SAS-mode (Tom Cook) and Stata-mode (Thomas
Lumley). 
<!-- The name is ESS.  Not ESS-mode. -->

<ul class="menu">
<li><a accesskey="1" href="#License">License</a>
<li><a accesskey="2" href="#Starting-an-ESS-Process">Starting an ESS Process</a>
<li><a accesskey="3" href="#New-Features">New Features</a>
<li><a accesskey="4" href="#Current-Features">Current Features</a>
<li><a accesskey="5" href="#Stability">Stability</a>
<li><a accesskey="6" href="#Requirements">Requirements</a>
<li><a accesskey="7" href="#Latest-Version">Latest Version</a>
<li><a accesskey="8" href="#Installation">Installation</a>
<li><a accesskey="9" href="#Reporting-Bugs">Reporting Bugs</a>
<li><a href="#Mailing-Lists">Mailing Lists</a>
<li><a href="#Authors">Authors</a>
</ul>

<div class="node">
<p><hr>
<a name="License"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Starting-up">Starting up</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#General-Information">General Information</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.1 License</h3>

<p>ESS is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

   <p>ESS is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
in the file COPYING in the same directory as this file for more
details.

<div class="node">
<p><hr>
<a name="Starting-up"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#New-Features">New Features</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#License">License</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<h3 class="section">1.2 Starting an ESS process</h3>

<p>To start an S session on Unix or on Windows when you
use the Cygwin bash shell, simply type <kbd>M-x S RET</kbd>.

   <p>To start an S session on Windows when you
use the MSDOS prompt shell, simply type <kbd>M-x S+6-msdos RET</kbd>.

<div class="node">
<p><hr>
<a name="New-Features"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Current-Features">Current Features</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#Starting-up">Starting up</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.3 New Features</h3>

<p>Changes/New Features in 5.3.7:
     <ul>
<li><acronym>ESS</acronym>: <code>ess-default-style</code> now *is* customizable, i.e.,
  changing its value in <samp><span class="file">~/.emacs</span></samp> now does have the desired effect. 
<li><acronym>ESS</acronym>: <code>ess-font-lock-mode</code> is a new variable (default: t)
which controls whether font-locking is enabled in ESS buffers. 
<li><acronym>ESS[R]</acronym>: for XEmacs on Windows; another tweak to find R versions
<li><acronym>ESS[SAS]</acronym>: font-locking updated for ODS and SAS Bayesian Procedures;
a more consistent handling of SAS options by
<code>ess-sas-submit-command-options</code> which is buffer-local; portable
snooze for MS Windows via customize-able <code>ess-sleep-for</code> (floats welcome)
</ul>

   <p>Changes/New Features in 5.3.6:
     <ul>
<li><acronym>ESS</acronym>: for XEmacs, using &ldquo;gnuclient&rdquo; (without a &ldquo;-q&rdquo;) works for
 things like fix() after M-x gnuserv-start has been done. 
<li><acronym>ESS[R]</acronym>: M-x R-newest should now work in more situations on MS
 Windows, e.g., when R has been installed in a non-default "ProgramFiles"
 directory tree.  In these cases, there's no need to specify the name (and
 full path) of the R program anymore. 
<li><acronym>ESS[R]</acronym>: For XEmacs, startup (with new tooltip code) works again. 
</ul>

   <p>Changes/New Features in 5.3.5:
     <ul>
<li><acronym>ESS[R]</acronym> a new defun is available, <kbd>M-x R-newest</kbd>, which will start
the newest version of R that it can find on your system. 
<li><acronym>ESS[R]</acronym> add Sven Hartenstein's &ldquo;R function arguments tips&rdquo;
 functionality, via new file <samp><span class="file">../lisp/essd-r-args.el</span></samp>. 
 Note that this includes an &ldquo;electric "("&rdquo; behavior inside <code>R-mode</code>
 which is <em>active by default</em> and can be customized via
 <code>ess-r-args-electric-paren</code>; i.e., use <code>(setq
 ess-r-args-electric-paren nil)</code> to turn it off.  Further,
 <code>ess-r-args-show-as</code> allows to switch to the &ldquo;tooltip&rdquo; mode. 
<li><acronym>ESS</acronym>: functions <code>ess-get-pdf-viewer</code> and *-ps-viewer; built on new
 customizable variables <code>ess-pdf-viewer-pref</code> and
 <code>ess-ps-viewer-pref</code>; currently used in <code>ess-swv-PDF</code> and
 <code>*-PS</code>. 
<li><acronym>ESS[R]</acronym> Improved <code>ess-swv-PDF</code> to run pdf viewer only if
 pdflatex was ok
<li><acronym>ESS[R]</acronym> Improved <code>ess-swv-weave</code> to start R automatically if
 none is running. 
<li><acronym>ESS</acronym>: Do no longer ask <em>which</em> ESS process to use if there
 is only one. 
</ul>

   <p>Changes/New Features in 5.3.4:
     <ul>
<li><acronym>ESS[R]</acronym> now better work with options(error=recover); and the
new default of CHM help files on windows. 
<li><acronym>ESS[R]</acronym> some more cleanup in the &ldquo;sweave&rdquo; functions
<li>miscellaneous fixes
</ul>

   <p>Changes/New Features in 5.3.3:
     <ul>
<li><acronym>ESS[S]</acronym> fix buglet (5.3.2 only) which left command prompt in
&ldquo;execute buffer&rdquo; and hence help files. 
<li>new customizable variable <code>ess-display-buffer-reuse-frames</code>
set to true (which changes default behavior) such that execution or
help *frames* are reused. 
</ul>

   <p>Changes/New Features in 5.3.2:
     <ul>
<li>Classic BUGS now supported by <code>(require 'essd-bugs)</code> with <acronym>ESS[BUGS]</acronym>
      and JAGS by <code>(require 'essd-jags)</code> with <acronym>ESS[JAGS]</acronym>.  But, only one
      of them can be used at a time since they don't play nice together.  Also,
      <kbd>C-c C-c</kbd> is now bound to the function <code>ess-bugs-next-action</code>
      (<kbd>F12</kbd> has been retired).  And finally, note that <samp><span class="file">essl-bug.el</span></samp>
      is deprecated and the replacement is <samp><span class="file">essl-bugs.el</span></samp>. 
<li><acronym>ESS[R]</acronym> Improved some of the &ldquo;Sweave-make&rdquo;
 functions (yet scarcely documented) in <samp><span class="file">ess-swv.el</span></samp>. 
<li><acronym>ESS[S]</acronym> No longer mess with .Last.value (nor in other &ldquo;languages&rdquo;). 
</ul>

   <p>Changes/New Features in 5.3.1:
     <ul>
<li>See the docs for 2 ways to install <acronym>ESS</acronym> for XEmacs
          <ol type=1 start=1>
      <li>by uncommenting the XEmacs part of
            Section 1 of <samp><span class="file">Makeconf</span></samp> and performing <code>make install</code>
      <li>by unpacking either
            <samp><span class="file">ess-5.3.1.tgz</span></samp> or <samp><span class="file">ess-5.3.1.zip</span></samp> into
            <samp><span class="file">PREFIX/lib/xemacs/site-packages</span></samp> on unix or
            <samp><span class="file">PREFIX\XEmacs\site-packages</span></samp> on windows
          </ol>
<li><acronym>ESS[R]</acronym>: fixed bugs so that Rterm.exe can be found by XEmacs
<li><acronym>ESS[S]</acronym>: <kbd>ess-toggle-S-assign-key</kbd> is slightly changed; in
 particular, the default <code>ess-assign-key</code> is now <kbd>C-x =</kbd>. 
<li><acronym>ESS[R]</acronym>: <kbd>M-x R-site-search</kbd> is a new (slightly experimental)
 utility similar to R's <code>RSiteSearch(..)</code> but with the advantage of
 using Emacs' preferred browser, see <code>browse-url-browser-function</code>
</ul>

   <p>Changes/New Features in 5.3.0:
     <ul>
<li><acronym>ESS[BUGS]</acronym>: sanely re-format statistical output, <samp><span class="file">.bog</span></samp>,
from scientific notation to numbers rounded with 4 decimal places
with <kbd>M-x ess-bugs-sci-round-to-4-dp</kbd>. 
<li>The keys for navigating among section headings in help buffers
worked, but only for one language per session; they should now work for
multiple languages.  (They were also broken on Windows machines.) 
<li><acronym>ESS[S]</acronym> long standing buglets in the internal logic for loading
lisp code on Windows.  Particularly fixed behavior in help mode with S-plus
GUI. 
<li>New variable, <code>ess-use-inferior-program-name-in-buffer-name</code>,
which enables using the executable name instead of the dialect name for
R. Feature request. 
<li><acronym>ESS[S]</acronym> <kbd>ess-execute-screen-options</kbd>
now also works correctly when there is more than one window *side-by-side*
in the same frame and runs in the correct buffer also when there is more
than one S buffer. 
<li>i<acronym>ESS[S]</acronym><!-- /@w --> new functions <code>ess-eval-paragraph-and-step</code> and
 <code>ess-eval-function-or-paragraph-and-step</code> are bound to keys
 <kbd>C-c C-p</kbd> and <kbd>C-c C-c</kbd> respectively and to the menu in
 <acronym>ESS</acronym>-mode; also bound in the help mode (for evaluating examples). 
<li><acronym>ESS[S]</acronym> new function <code>ess-toggle-S-assign-key</code> allows to
assign the &ldquo; &lt;- &rdquo; insertion to an arbitrary key. 
</ul>

   <p>Changes/New Features in 5.2.12:
     <ul>
<li><acronym>ESS[SAS]</acronym>: <kbd>M-;</kbd> fixed, but the XEmacs function <code>comment-dwim</code>
may be broken, if so, use <kbd>M-x comment-region</kbd> and <kbd>M-x
uncomment-region</kbd> instead; only valid PROCs are fontified which is very
helpful finding syntax errors (currently supported: BASE, ETS, FSP, GRAPH,
IML, INSIGHT and STAT); the &ldquo;feature&rdquo; where <kbd>F</kbd>-keys take you to an
empty buffer when the requested destination is a file that does not exist
has been fixed, now the request results in a no-op. 
Further, sas-mode now also works in simple terminals. 
<li>Rterm/Cygwin combination works under Microsoft Windows. 
<li><acronym>ESS[R]</acronym>: internal calls use baseenv() instead of NULL and
define 'baseenv' where needed. 
<li>New experimental support for installing ESS.  See the file
<samp><span class="file">lisp/ess-install.el</span></samp>. 
</ul>

   <p>Changes/New Features in 5.2.11:
     <ul>
<li>ESS Info entry and <samp><span class="file">dir</span></samp> handled more effectively for GNU Emacs users
<li><acronym>ESS[SAS]</acronym>: temporary files created for batch submission of a
region are now named based on the current file; see <code>ess-sas-file-root</code>
for details; all <code>lag</code> and <code>dif</code> functions now fontified correctly
<li>iESS[SAS]: fixed a few nagging bugs, however, still does not appear to
work at this time; please let us know if you have any ideas. 
<li><acronym>ESS[S]</acronym>: Support for running other versions of Splus has been
added for unix.  Two new variables, <code>ess-s-versions</code> and
<code>ess-s-versions-list</code>, are used to tell ESS what other versions of
Splus you would like to run. 
</ul>

   <p>Changes/New Features in 5.2.10:
     <ul>
<li><acronym>ESS[R]</acronym>: ess-r-versions can no longer be customized (since the
customization was not taking effect unless customizations were loaded
before ESS).  Its value has been changed so that it will also find R
executables beginning &ldquo;R-devel&rdquo; and &ldquo;R-patched&rdquo;.  If you wish to
change this variable, it must be set in your <samp><span class="file">.emacs</span></samp> before ESS is
loaded. 
<li>Installation with GNU Make enhanced:  unix and unix-like
operating systems will now be able to install <acronym>ESS</acronym> for all
users in either a GNU Emacs site-lisp or an XEmacs package
configuration by editing <samp><span class="file">lisp/ess-site.el</span></samp> and <samp><span class="file">Makeconf</span></samp>
accordingly, then issuing <code>make install</code>
<li><acronym>ESS[S]</acronym>: Filename completion (inside strings) now also works in
XEmacs for R and S-plus. 
<!-- working around a bug in XEmacs -->
</ul>

   <p>Changes/New Features in 5.2.9:
     <ul>
<li><acronym>ESS[R]</acronym> for Windows:  the \ directory character bug
with respect to ess-load-file has been eradicated. 
<li>i<acronym>ESS[SAS]</acronym><!-- /@w -->: <kbd>C-c C-r</kbd> and <kbd>C-c C-b</kbd> once again
work as intended and documented. 
<li><acronym>ESS[S]</acronym>: M-x ess-fix-EQ-assign is a bit more agressive. 
<li><acronym>ESS[S]</acronym>: Imenu now also shows setAs(), etc. 
<li><acronym>ESS[R]</acronym>: R function pattern enhanced with underlying code such that
 <kbd>M-C-a</kbd> (<code>ess-beginning-of-function</code>) etc now work for many more
 cases, including S4 method definitions. 
<li>i<acronym>ESS[R]</acronym><!-- /@w -->: myOwnhelp(1) no longer wrongly triggers help(1). 
<li><acronym>ESS[R]</acronym>: Improved detection of bogus help buffers: valid help
 buffers containing with the string &ldquo;no documentation&rdquo;(e.g. contour)
 were being treated as bogus. 
<li><acronym>ESS[R]</acronym>: In R help buffers, if <code>options("help.try.all.packages" =
 TRUE)</code> then <code>?rlm</code> will list which packages rlm is defined in.  This help
 buffer is not bogus, but instead is now relabelled &ldquo;*help[R](rlm in
 packages)*&rdquo;. 
<li><acronym>ESS[STA]</acronym>: add &ldquo;//&rdquo; as comment starting character to syntax-table. 
</ul>

   <p>Changes/New Features in 5.2.8:
     <ul>
<li>iESS: [Tab] completes <strong>file</strong> names &ldquo;inside string&rdquo; as in
earlier (&lt;= 5.2.3) ESS versions. 
</ul>

   <p>Changes/New Features in 5.2.7:
     <ul>
<li>If you use Custom to change the variable ess-toolbar-items,
the new toolbar is used in all subsequent ESS buffers. 
<li><acronym>ESS[SAS]</acronym>: new feature:  if ess-sas-log-max &gt;0 and
your .log grows to more than ess-sas-log-max bytes, just
the first ess-sas-log-max bytes are refreshed; this is helpful when your .sas program
generates lots of error messages and gets too big for emacs to display
<li><acronym>ESS[R/S]</acronym>: <kbd>M-;</kbd> in R/S editing modes will now indent with
either one or two hashes depending on context. 
<li><acronym>ESS[R]</acronym>: David Whiting's Sweave extensions (to 'noweb')
are now available (from ess-swv.el loaded by default). 
</ul>

   <p>Changes/New Features in 5.2.6:
     <ul>
<li>Removed non-ASCII characters in a few files. 
<li><acronym>ESS[R]</acronym>: now works better when UTF-8 locale is active; in
 particular, you get correct directional quotes in R's startup message
 for R-devel (unstable development version of R 2.1.0) when using
 environment variables LANGUAGE=en@quot LC_ALL=en_US.UTF-8
<li><acronym>ESS[SAS]</acronym>: toggling of .log mode improved (<kbd>F10</kbd>); toggling of
.lst mode now also available (<kbd>C-F10</kbd>); killing all buffers associated
with .sas program no longer bound to <kbd>C-F10</kbd> since its a bit overzealous. 
<li>S-Plus 7 for Windows is now recognized. 
<li><acronym>ESS[S]</acronym> (incl. R): in auto-fill mode, strings are not wrapped anymore. 
<li><acronym>ESS[S]</acronym> (incl. R): font-lock now correctly differs between R and S,
e.g., for "_"; both now fontify warning(.) and S does terminate() additionally. 
<li>Support for `bell' aka `beep' aka `ding' aka `alarm' in all inferior
modes: When \a is output &ldquo;to the the console&rdquo; at the beginning of a line,
the bell is rung. 
</ul>

   <p>Changes/New Features in 5.2.5:
     <ul>
<li><acronym>ESS[R]</acronym>: <kbd>C-c C-q</kbd> or `<samp><span class="samp">Quit S</span></samp>' from the menu now should work
(again and less klunkily) and do not append `<samp><span class="samp">-exited</span></samp>' to the
buffer name.  Further, the behavior of <code>(ess-cleanup)</code>, called from
ess-quit, now depends on the new customizable variable
<code>ess-S-quit-kill-buffers-p</code> which defaults to <code>nil</code>. 
Consequently, the question <em>&ldquo;Delete all buffers associated
with ..?&rdquo;</em> will not be asked anymore by default. 
<li><acronym>ESS[SAS]</acronym> &ndash; ess-ebcdic-to-ascii-search-and-replace will now work
with the <code>recode</code> application as well which is available on many platforms
<li><acronym>ESS[S]</acronym> (incl. R): Name completion for slots of S4 objects now works! 
</ul>

   <p>Changes/New Features in 5.2.4:
     <ul>
<li>The documentation now includes an overview of how to use the emacs
TAGS facility for S functions.  (The distribution also used to contain a
directory <samp><span class="file">etc/other/Tags</span></samp> where a ~1990 version of <samp><span class="file">etags.c</span></samp> was
distributed; this is no longer relevant and so has been deleted.) 
<li><acronym>ESS[SAS]</acronym> &ndash; When you are working with EBCDIC files on an ASCII
platform, .log NOTEs may display as gibberish since the EBCDIC
characters are not converted to ASCII prior to their display.  So,
the function ess-ebcdic-to-ascii-search-and-replace is provided for
convenience and is bound to <kbd>C-F11</kbd>.  This function requires the
<code>dd</code> command (only available on unix or unix-like platforms). 
<li>ESS: Completion of object names is now always done dynamically rather
than allowing the option of using a pre-computed database (by
<code>ess-create-object-name-db</code>) since modern computers seem fast
enough for dynamic completion.  (We expect few users, if any, have
been using the pre-computed database method.) 
<li>ESS: object completion in iESS buffers running on Windows was
very slow (for GNU Emacs, but not XEmacs) and has now been fixed. 
Further, it was more or less broken for all versions of S-plus 6.x,
and has been fixed to work everywhere but with the Windows' GUI of
S-plus.  The list of objects now shows unique names also when an
object appears more than once in the search path. 
<li><acronym>ESS[R]</acronym>: Completion of object names now also includes those
starting with &ldquo;.&rdquo;. 
</ul>

   <p>Changes/New Features in 5.2.3:
     <ul>
<li>ESS: When new inferior ESS processes are created, by default they
will replace the current buffer (this restores behavior from pre
5.2.0). If you wish new ESS processes to start in another window of the
current frame, set inferior-ess-same-window to nil. 
<li>New variables inferior-Splus-args and inferior-R-args provide a
way to pass command line arguments to starting S and R processes. 
</ul>

   <p>Changes/New Features in 5.2.2:
     <ul>
<li>bug-fixes for 5.2.1 (require 'executable), html docs, etc. 
<li>ess-lisp-directory/../doc/info added to Info-directory-list
if ess-info not found by info
<li><acronym>ESS[R]</acronym>: If you have other versions of R on your
exec-path, such as "R-1.8.1" with Unix or "rw1081" with Windows,
ESS will find them and create appropriate functions, such as
<kbd>M-x R-1.8.1</kbd> or <kbd>M-x rw1081</kbd>, for calling them. 
By default only Unix programs beginning "R-1" and
"R-2" and Windows programs parallel to the
version of R in your exec-path will be found,
but see ess-r-versions and ess-rterm-versions for ways to find other
versions of R. 
<li><acronym>ESS[R]</acronym>: Other versions of R, such as "R-1.8.1" on Unix and "rw1081" on
Windows, are added to the
"ESS / Start Process / Other" menu. 
<li><acronym>ESS[S]</acronym>: If you have other versions of S-Plus on your Windows computer,
such as S-Plus 6.1 or S-Plus 4.5, ESS will find them and create appropriate
functions, such as <kbd>M-x splus61</kbd>, for calling the console version (Sqpe)
inside an emacs buffer.  By default only
programs installed in the default location will be found, but see
ess-SHOME-versions for ways to find other versions of S-Plus. 
<li><acronym>ESS[S]</acronym>: Other versions of Sqpe on Windows, such as "splus61",
are added to the
"ESS / Start Process / Other" menu. 
<li><acronym>ESS[R]</acronym>: (bug fix) ess-quit (bound to <kbd>C-c C-q</kbd>) should now quit the
inferior R process, when issued from either the inferior buffer, or from
a .R buffer. 
</ul>

   <p>Changes/New Features in 5.2.1:
     <ul>
<li><acronym>ESS[S]</acronym> (R and S-plus): now have toolbar support
with icons to evaluate code in the inferior process or to switch
there.  This code is experimental and likely to change as XEmacs/Emacs
issues get resolved. The toolbar should be enabled if your Emacs
displays images, but can be disabled with the variable ess-use-toolbar. 
Thanks to David Smith from Insightful for the S-plus logo. 
<li><acronym>ESS[SAS]</acronym>: ess-sas-graph-view (<kbd>F12</kbd>) enhanced; you can specify
external file viewers for each graphics file type via the alist
ess-sas-graph-view-viewer-alist; also .jpg/.gif are now handled
by image-mode on XEmacs, if available, otherwise by graphics
primitives as before
</ul>

   <p>Changes/New Features in 5.2.0:
     <ul>
<li><acronym>ESS[BUGS]</acronym>:  new info documentation!  now supports interactive
processing thanks to <a href="mailto:Aki.Vehtari@hut.fi">Aki Vehtari</a>;
new architecture-independent unix support as well as support for BUGS v. 0.5
<li><acronym>ESS[SAS]</acronym>:  convert .log to .sas with ess-sas-transcript;
info documentation improved; Local Variable bug fixes;
SAS/IML statements/functions now highlighted; files edited
remotely by ange-ftp/EFS/tramp are recognized and pressing
SUBMIT opens a buffer on the remote host via the local variable
ess-sas-shell-buffer-remote-init which defaults to "ssh";
changed the definition of the variable ess-sas-edit-keys-toggle
to boolean rather than 0/1; added the function ess-electric-run-semicolon
which automatically reverse indents lines containing only "run;";
<kbd>C-F1</kbd> creates MS RTF portrait from the current buffer;
<kbd>C-F2</kbd> creates MS RTF landscape from the current buffer;
<kbd>C-F9</kbd> opens a SAS DATASET with PROC INSIGHT rather than PROC FSVIEW;
"inferior" aliases for SAS batch:  <kbd>C-c C-r</kbd> for submit region,
<kbd>C-c C-b</kbd> for submit buffer, <kbd>C-c C-x</kbd> for goto .log; <kbd>C-c C-y</kbd> for goto .lst
<li><acronym>ESS[S]</acronym>: Pressing underscore ("_") once inserts " &lt;- " (as before);
pressing underscore twice inserts a literal underscore.  To stop this
smart behaviour, add "(ess-toggle-underscore nil)" to your .emacs after
ess-site has been loaded;
ess-dump-filename-template-proto (new name!) now can be
customized successfully (for S language dialects);
Support for Imenu has been improved; set ess-imenu-use-S to non-nil to
get an "Imenu-S" item on your menubar;
ess-help: Now using nice underlines (instead of `nuke-* ^H_')
<li><acronym>ESS[R]</acronym>:  After (require 'essa-r), <kbd>M-x ess-r-var</kbd> allows to load
numbers from any Emacs buffer into an existing *R* process;
<kbd>M-x ess-rdired</kbd> gives a &ldquo;directory editor&rdquo; of R objects;
fixed ess-retr-lastvalue-command, i.e. .Last.value bug
(thanks to David Brahm)
<li>ESS: Support for creating new window frames has been added to
ESS.  Inferior ESS processes can be created in dedicated frames by
setting inferior-ess-own-frame to t.  ESS help buffers can also open in
new frames; see the documentation for ess-help-own-frame for details. 
(Thanks to Kevin Rodgers for contributing code.) 
</ul>

   <p>Changes/New Features in 5.1.24:
     <ul>
<li>The version number is now correct even inside ESS/Emacs
</ul>

   <p>Changes/New Features in 5.1.23:
     <ul>
<li>Minor more Makefile clean up. 
</ul>

   <p>Changes/New Features in 5.1.22:
     <ul>
<li>Besides info documentation, PDF and HTML
documentation are also provided (instead of built using "make") and available
on the web as well; see <a href="http://ess.r-project.org/">ESS web page</a> and <a href="http://lib.stat.cmu.edu/general/ESS/doc">StatLib</a>
<li>Now that info documentation is available, the
README.* files are no longer supported.  However, they
are still distributed for what it's worth. 
<li>ESS is now an XEmacs package!  See
<a href="http://www.xemacs.org/Install/index.html">XEmacs Installation HOWTO</a>
for details (specifically, items 10-15). 
<li><acronym>ESS[SAS]</acronym>: more user-friendly enhancements for remote
SAS batch jobs with Kermit file transfers (LOG and OUTPUT
function key features now supported).  Multiple shells
now supported so you can run SAS on different computers
from different buffers by setting the buffer-local variable
ess-sas-shell-buffer to unique buffer names. 
<li>Major re-vamping of Makefile/Makeconf. 
</ul>

   <p>Changes/New Features in 5.1.21:
     <ul>
<li><acronym>ESS[SAS]</acronym>: info documentation now available!, see
ESS-&gt;Help for SAS; <kbd>F12</kbd> opens GSASFILE nearest point for viewing
either within emacs, when available, or via an external viewer;
more syntax highlighting keywords; more enhancements for remote
SAS batch jobs with Kermit; new framework for remote SAS interactive
jobs, see ess-remote
<li><acronym>ESS[S]</acronym>: info documentation now available!, see
ESS-&gt;Help for the S family
<li>Makefile: tag now independent of rel; info files
made by doc/Makefile and installed in new info sub-directory
</ul>

   <p>Changes/New Features in 5.1.20:
     <ul>
<li>New `options()$STERM' in the S dialects (S, S-Plus, R). 
The S program can determine the environment in which it is
currently running.  ESS sets the option to `iESS' or `ddeESS'
when it starts an S language process.  We recommend other specific
values for S language processes that ESS does not start. 
<li>New `ess-mouse-me' function, assigned to S-mouse-3 by default. 
User may click on a word or region and then choose from the
menu to display the item, or a summary, or a plot, etc. 
This feature is still under development. 
<li>GNU Emacs 21.1 is now supported (fixed for S dialects, SAS &amp; BUGS),
(some from Stephen Eglen). 
<li>XEmacs 21.x is now supported (fixed w32-using-nt bug)
<li>XEmacs on Win (NT) is better supported. 
<li>Workaround for bug in Sqpe+6 (S-PLUS 6 for Win). 
<li>should now work even when imenu is not available (for old XEmacsen). 
<li><acronym>ESS[SAS]</acronym>: XEmacs-Imenu fix; <kbd>C-TAB</kbd> is globalized along with your
function-key definitions, if specified; you can specify your SAS
library definitions outside of autoexec.sas for ess-sas-data-view
with SAS code placed in the variable ess-sas-data-view-libname,
also the dataset name is defaulted to the nearest permanent dataset
to point; Speedbar support now works for permanent datasets, please
ignore first./last.; new font-locking is now the default with more
improvements for font-locking PROCs, macro statements, * ; and %* ;
comments; you can toggle sas-log-mode with <kbd>F10</kbd> which will font-lock
your .log (if it isn't too big); submit remote .sas files accessed
with ange-ftp, EFS or Tramp (Kermit is experimental) by setting
ess-sas-submit-method to 'sh; ess-sas-submit-command and
ess-sas-submit-command-options are buffer-local so you can have
local file variable sections at the end of your .sas files to
request different executables or specify special options and the
local file variables are re-read at submit instead of only at file
open so that if you make a change it is picked up immediately;
<li><acronym>ESS[BUGS]</acronym>: font-lock with `in' fixed. 
<li>for STATA: font-lock bug fixed. 
<li>for Rd mode: <kbd>C-c C-v</kbd> and `switch-process' in menu. 
further, <kbd>C-c C-f</kbd> prefix (Rd-font) for inserting or surrounding a word
by things such as \code{.}, \code{\link{.}}, \emph{.} etc. 
<li>new functions (ess-directory-function) and (ess-narrow-to-defun)
ess-directory &lt;-&gt; default-directory logic (Jeff Mincy). 
<li>Re-organized Makefile and fixed a few bugs. 
</ul>

   <p>Changes/New Features in 5.1.19:
     <ul>
<li>S+6 now supported (Tony Rossini (Unix) and Rich Heiberger (Windows))
<li>New BUGS support through <acronym>ESS[BUGS]</acronym> mode (Rodney Sparapani)
Templates assist you in writing .bug and .cmd code (.cmd and .log
are replaced by .bmd and .bog to avoid emacs extension collisions). 
Substitution" parameters facilitate "automagic" generation of
data...in" and "init...in" filenames, "const N=" from your data
file and "monitor()/stats()" commands.  Activated by pressing <kbd>F12</kbd>. 
<li>Fixes for `ess-smart-underscore' SAS breakage (Rich Heiberger)
<li>You can change between PC and Unix, local and global SAS function-key
definitions interactively (Rich Heiberger)
<li><kbd>C-Submit</kbd> a highlighted region to SAS batch (Rodney Sparapani)
<li>New and improved SAS syntax highlighting (Rodney Sparapani)
To get the new functionality, set ess-sas-run-make-regexp to nil. 
Also available in .log files via <kbd>F10</kbd>. 
<li>Open a permanent SAS dataset for viewing via <kbd>F9</kbd> (Rodney Sparapani)
You must have the library defined in autoexec.sas for it to work. 
<li>User-friendly defaults for `sas-program', `ess-sas-batch-pre-command'
and `ess-sas-batch-post-command' as well Customize support for these
and other <acronym>ESS[SAS]</acronym> variables (Rodney Sparapani)
<li>`ess-sas-suffix-2' now defaults to .dat via <kbd>F11</kbd> (Rodney Sparapani)
<li>Emacs/XEmacs, Unix/Windows issues collectively handled in ess-emcs.el
<li>defadvice solves problem of missing *ESS* (thanks to Jeff Mincy)
<li>Improved manual a bit by including things that were only in `README'. 
</ul>

   <p>Changes/New Features in 5.1.18:
     <ul>
<li>New `ess-smart-underscore' function, now assigned to "_" by default. 
Inserts `ess-S-assign' (customizable " &lt;- "), unless inside string
and comments where plain "_" is used instead. (MM)
<li>Fixes for longstanding interactive SAS breakage (RMH)
</ul>

   <p>Changes/New Features in 5.1.17:
     <ul>
<li>Documentation for Windows Installation (Rich Heiberger)
<li>removal of ess-vars, finalization of customize support (in the
sense that there is no more use of ess-vars, but that we need to
fix ess-cust) (AJ Rossini)
<li>Many small (and large) fixes/contributions (MMaechler)
<li>addition of the "S-equal" variable and provide <kbd>M-x ess-add-MM-keys</kbd>
a way to remap "_" to `ess-S-assign', typically " &lt;- ", but
customizable. (MMaechler)
</ul>

   <p>Changes/New Features in 5.1.16:
     <ul>
<li>BUG FIXES
<li>Better SAS support
</ul>

   <p>Changes/New Features in 5.1.15:
     <ul>
<li>BUG FIXES
</ul>

   <p>Changes/New Features in 5.1.14:
     <ul>
<li>Yet more fixes to SAS mode, (Rich Heiberger and Rodney Sparapani)
<li>Customize support (for most Emacsen which support it) (AJRossini)
<li>ARC and ViSta support out of the box, and fixes for XLispStat (AJRossini)
</ul>

   <p>Changes/New Features in 5.1.13:
     <ul>
<li>Version numbering finally all depending on the ./VERSION file,
thanks to Martin Maechler. 
<li>Yet more fixes to SAS mode, thanks to Rich Heiberger. 
</ul>

   <p>Changes/New Features in 5.1.12:
     <ul>
<li>Splus 5.1 stabilized, thanks to Martin Maechler, Bill Venables,
Chuck Taylor, and others. 
<li>More fixes to SAS mode, thanks to Rodney Sparapani
and Rich Heiberger. 
</ul>

   <p>Changes/New Features in 5.1.11:
     <ul>
<li>More fixes to Stata mode, thanks to
<a href="mailto:brendan@essex.ac.uk">Brendan Halpin</a>. 
<li>fixed bugs in ESS-elsewhere, thanks to many testers
<li>README.SPLUS4WIN has DETAILED instructions for S-PLUS 2000, thanks
to <a href="mailto:brahm@alum.mit.edu">David Brahm</a>. 
<li>Fixes to SAS mode, thanks to Rodney Sparapani
</ul>

   <p>Changes/New Features in 5.1.10:
     <ul>
<li>More fixes to Stata mode
<li>primitive generic version of ESS-elsewhere
<li>Small fixes to SAS/Stata. 
</ul>

   <p>Changes/New Features in 5.1.9:
     <ul>
<li>Stata mode works
<li>Literate Data Analysis using Noweb works
</ul>

   <p>Changes/New Features in 5.1.8:
     <ul>
<li>Bug fixes
<li>R documentation mode defaults changed
</ul>

   <p>Changes/New Features in 5.1.2:
     <ul>
<li>able to use inferior iESS mode to
communicate directly with a running S-Plus 4.x process using the
Microsoft DDE protocol.  We use the familiar (from Unix ESS) <kbd>C-c C-n</kbd>
and related key sequences to send lines from the S-mode file to the
inferior S process.  We continue to edit S input files in <acronym>ESS[S]</acronym> mode
and transcripts of previous S sessions in ESS Transcript mode.  All
three modes know the S language, syntax, and indentation patterns and
provide the syntactic highlighting that eases the programming tasks. 
</ul>

<div class="node">
<p><hr>
<a name="Current-Features"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Stability">Stability</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#New-Features">New Features</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.4 Current Features</h3>

     <ul>
<li>Languages Supported:
          <ul>
  <li>S family (S 3/4, S-PLUS 3.x/4.x/5.x/6.x/7.x/8.x, and R)
  <li>SAS
  <li>BUGS/JAGS
  <li>Stata
  <li>XLispStat including Arc and ViSta
  </ul>
     <li>Editing source code (S family, SAS, BUGS/JAGS, XLispStat)
          <ul>
  <li>Syntactic indentation and highlighting of source code
  <li>Partial evaluation of code
  <li>Loading and error-checking of code
  <li>Source code revision maintenance
  <li>Batch execution (SAS, BUGS/JAGS)
  <li>Use of imenu to provide links to appropriate functions
  </ul>
     <li>Interacting with the process (S family, SAS, XLispStat)
          <ul>
  <li>Command-line editing
  <li>Searchable Command history
  <li>Command-line completion of S family object names and file names
  <li>Quick access to object lists and search lists
  <li>Transcript recording
  <li>Interface to the help system
  </ul>
     <li>Transcript manipulation (S family, XLispStat)
          <ul>
  <li>Recording and saving transcript files
  <li>Manipulating and editing saved transcripts
  <li>Re-evaluating commands from transcript files
  </ul>
     <li>Help File Editing (R)
          <ul>
  <li>Syntactic indentation and highlighting of source code. 
  <li>Sending Examples to running ESS process. 
  <li>Previewing
  </ul>
     </ul>

<div class="node">
<p><hr>
<a name="Stability"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Requirements">Requirements</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#Current-Features">Current Features</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.5 Stability</h3>

<p>Versions 5.3.x are meant to be release-quality versions.  While some
new features are being introduced, we are cleaning up and improving
the interface.  We know about some remaining documentation inconsistencies. 
Patches or suggested fixes with bug reports are much appreciated!

<div class="node">
<p><hr>
<a name="Requirements"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Latest-Version">Latest Version</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#Stability">Stability</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.6 Requirements</h3>

<p>ESS has been tested with

     <ul>
<li>R &gt;=0.49
<li>S-PLUS 3.3-4, 4.5, 2000, 5.0-1, 6.0-2, 7.0, 8.0
<li>S4
<li>SAS &gt;=6.12
<li>BUGS 0.5, 0.6
<li>JAGS 0.9, 1.0 (not quite working yet, patches welcome)
<li>Stata &gt;=6.0 (recent Stata support limited due to changes in Stata)
<!-- is anyone still using this? @item XLispStat >=3.50 -->
</ul>

   <p>on the following platforms

     <ul>
<li>Linux/x86 (all)
<li>Solaris/SPARC (all)
<!-- cannot confirm this right now @item SGI (all) -->
<li>MS Windows 98/NT/2000/XP (R, SPLUS 4.5/2000/6.0-2/7.0/8.0, SAS interactive only, and BUGS 0.6)
<li>Apple Mac OS X 10.3-4 (R, JAGS)
</ul>

   <p>with the following versions of emacs

     <ul>
<li>GNU Emacs 20.3-7, 21.1, 21.3-4, 22.1
<li>XEmacs 21.4.0-8, 21.4.9-13<a rel="footnote" href="#fn-1" name="fnd-1"><sup>1</sup></a>, 21.4.14-15, 21.4.17-21 (betas not supported, but 21.5.23+ may work)
<!-- @item GNU Emacs <20.3 and XEmacs <21.0@footnote{These releases of emacs are no -->
<!-- longer supported, so an upgrade is recommended if you plan to use ESS. -->
<!-- If you have GNU Emacs 19.29, see @xref{Unix installation}.  Also, note -->
<!-- that the `custom' library bundled with Emacs 19.34 is too _old_, its API is -->
<!-- incompatible with the `new custom' bundled with recent Emacsen. -->
<!-- The `new custom' for Emacs 19.34 is available for download -->
<!-- @uref{ftp://ftp.dina.kvl.dk/pub/Staff/Per.Abrahamsen/custom/custom-1.9962.tar.gz, here}.} -->
</ul>

<div class="node">
<p><hr>
<a name="Latest-Version"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Installation">Installation</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#Requirements">Requirements</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.7 Getting the Latest Version</h3>

<p>The latest released version of ESS is always available on the web at:
<a href="http://ess.r-project.org">ESS web page</a> or
<a href="http://lib.stat.cmu.edu/general/ESS/">StatLib</a>

<!-- There no longer is an anonymous CVS repository for ESS, due to lack of -->
<!-- interest, little demand, and problems with security. -->
<!-- text below modified from R-admin.texi (thanks to Kurt for the tip). -->
<p>The latest development version of ESS is available via
<a href="https://svn.R-project.org/ESS/">https://svn.R-project.org/ESS/</a>, the ESS Subversion repository.  If
you have a Subversion client (see <a href="http://subversion.tigris.org/">http://subversion.tigris.org/</a>),
you can download the sources using:
<pre class="smallexample">     % svn checkout https://svn.r-project.org/ESS/trunk <var>path</var>
</pre>
   <p class="noindent">which will put the ESS files into directory <var>path</var>.  Later,
within that directory, `svn update' will bring that directory up to
date.  Windows-based tools such as TortoiseSVN are also available for
downloading the files.  Alternatively, you can browse the sources with a
web browser at: <a href="https://svn.r-project.org/ESS/trunk">ESS SVN site</a>.  However, please use a subversion client instead to minimize the
load when retrieving.

   <p>If you remove other versions of ESS from your emacs load-path, you can
then use the development version by adding the following to .emacs:

<pre class="example">     (load "/path/to/ess-svn/lisp/ess-site.el")
</pre>
   <p>Note that https is required, and that the SSL certificate for the
Subversion server of the R project is

<pre class="smallexample">     Certificate information:
      - Hostname: svn.r-project.org
      - Valid: from Jul 16 08:10:01 2004 GMT until Jul 14 08:10:01 2014 GMT
      - Issuer: Department of Mathematics, ETH Zurich, Zurich, Switzerland, CH
      - Fingerprint: c9:5d:eb:f9:f2:56:d1:04:ba:44:61:f8:64:6b:d9:33:3f:93:6e:ad
</pre>
   <p class="noindent">(currently, there is no &ldquo;trusted certificate&rdquo;).  You can accept this
certificate permanently and will not be asked about it anymore.

<!-- NOTE: The above INCLUDES inst_svn.texi (Subversion/SVN Installation) -->
<!-- vvvvvvvvvvvv node name  *must* match the one in ./ess.texi ! -->
<div class="node">
<p><hr>
<a name="Installation"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Reporting-Bugs">Reporting Bugs</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#Latest-Version">Latest Version</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.8 Installation (from tar file)</h3>

<div class="node">
<p><hr>
<a name="Unix-installation"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Microsoft-Windows-installation">Microsoft Windows installation</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#Installation">Installation</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.9 Unix installation</h3>

     <ol type=1 start=1>

     <li>
<code>cd</code> to a directory where you keep emacs lisp files, or create a
new directory (for example, <samp><span class="file">$HOME/emacs</span></samp>) to hold the distribution. 
This directory will be referred to below as "the ESS distribution
directory".

     <p><em>Note for XEmacs packages:</em> ESS is no longer available as an XEmacs package. 
But, you can still install ESS into the XEmacs package system by choosing
<samp><span class="file">ESSDIR</span></samp>=<samp><span class="file">PREFIX/lib/xemacs/site-packages</span></samp>. 
ESS requires that the XEmacs sumo tarball (all XEmacs packages combined) also
be installed.  For information on installing XEmacs packages, follow this link:
<a href="http://www.xemacs.org/Documentation/packageGuide.html">Quickstart Package Guide</a>.

     <!-- It will contain, -->
<!-- at the end, the tar file @file{ess-VERSION.tar.gz}, and a directory for -->
<!-- the ESS source, which will be termed "the ESS-VERSION source directory". -->
<!-- Note that the .elc files may be installed elsewhere (as specified in the -->
<!-- Makefile) if desired. -->
<li>Retrieve the latest version from
<a href="http://ess.r-project.org/downloads/ess">ESS downloads area</a>
to <samp><span class="file">ESSDIR</span></samp>.

     <li>Extract the files from the disribution.
     <pre class="display">          If you are using GNU tar, <code>tar zxf ess-VERSION.tgz</code>.
          Otherwise, <code>gunzip &lt; ess-VERSION.tgz | tar xf -</code>,
     </pre>
     <p>The <code>tar</code> command will create the subdirectory <samp><span class="file">ess-VERSION</span></samp> and install
the files there.

     <!-- If you are using GNU Emacs 19.29, decompress/unarchive -->
<!-- @file{ESSDIR/ess-VERSION/lisp/19.29.tar.gz}, -->
<!-- read @file{ESSDIR/ess-VERSION/lisp/19.29/README}, follow the instructions -->
<!-- and you might be able to get ESS to work. -->
<!-- @emph{Please note that GNU Emacs 19.29 is no longer supported}. -->
<!-- For a list of supported versions of emacs, see @xref{Requirements}. -->
<li>Edit the file <samp><span class="file">ESSDIR/ess-VERSION/lisp/ess-site.el</span></samp> as explained in the
comments section of that file. 
<!-- Installations that are using ESS only for S-Plus -->
<!-- 6.x will probably not need to make any changes.  Installations that also -->
<!-- have one or more of (S4, S+3/4/5/6/7/8, R, SAS, BUGS, XLispStat, Stata) -->
<!-- may need to uncomment corresponding lines in @file{ESSDIR/ess-VERSION/lisp/ess-site.el}. -->

     <li>If you are using GNU Emacs add the line
     <pre class="example">          (load "ESSDIR/ess-VERSION/lisp/ess-site")
     </pre>
     <p>to <samp><span class="file">$HOME/.emacs</span></samp>.  For XEmacs, if you followed the XEmacs package system
installation advice, add the line
     <pre class="example">          (require 'ess-site)
     </pre>
     <p>to <samp><span class="file">$HOME/.xemacs/init.el</span></samp>.  Otherwise, for XEmacs, add the line
     <pre class="example">          (load "ESSDIR/ess-VERSION/lisp/ess-site")
     </pre>
     <p>to <samp><span class="file">$HOME/.xemacs/init.el</span></samp>.

     <!-- GNU Emacs uses @file{default.el} or -->
<!-- @file{site-init.el} and XEmacs uses @file{site-start.el} for the system -->
<!-- installation file). -->
<!-- Alternatively, if @file{ess-site.el} is in your current @code{load-path}, then: -->
<!-- @example -->
<!-- (require 'ess-site) -->
<!-- @end example -->
<!-- to configure emacs for ESS. -->
<li>That's it!  ESS is now ready to use.  (The remaining step below is only for a
custom installation.)  To edit statistical programs, just open files with the
requisite extensions (<samp><span class="file">.R</span></samp> for R, <samp><span class="file">.sas</span></samp> for SAS, <samp><span class="file">.bug</span></samp> for BUGS,
etc.).  To start a statistical process within emacs, such as R, type <code>M-x R</code>.

     <!-- @item -->
<!-- (OPTIONAL) If you are running S-PLUS or R, you might consider -->
<!-- installing the database files.  From within emacs, @code{C-x d} to the -->
<!-- directory containing ESS.  Now: -->
<!-- @example -->
<!-- M-x S+6 -->
<!-- @end example -->
<!-- to get S running.  Once you see the SPLUS prompt, do: -->
<!-- @example -->
<!-- M-x ess-create-object-name-db -->
<!-- @end example -->
<!-- (this will create the file @file{ess-sp6-namedb.el}; if it isn't in the -->
<!-- ESS directory, move it there). -->
<!-- Then, completions will be autoloaded and will not be regenerated for -->
<!-- every session. -->
<!-- For R, do the same, using -->
<!-- @example -->
<!-- M-x R -->
<!-- @end example -->
<!-- and then @code{M-x ess-create-object-name-db} creating -->
<!-- @file{ess-r-namedb.el}; if it isn't in the ESS directory, move it there). -->
<li><b>(OPTIONAL) READ THIS ITEM THOROUGHLY BEFORE STARTING</b>:

     <p>If you want to place the compiled files in other locations edit the
<code>LISPDIR</code>, <code>INFODIR</code> and <code>ETCDIR</code> entries in Section 1 of
<samp><span class="file">Makeconf</span></samp> in the <samp><span class="file">ESSDIR/ess-VERSION</span></samp> directory (if you are
using XEmacs, then uncomment the XEmacs subsection in Section 1).

     <p>You can compile those files by:
     <pre class="example">          make all
     </pre>
     <p>When that completes successfully, install the compiled files:
     <pre class="example">          make install
     </pre>
     <!-- This will install the compiled info files and lisp files.  If you are an -->
<!-- XEmacs user, then you should be done.  If not, then you may have to -->
<!-- edit/create the file @file{dir} that is found in the directory specified -->
<!-- by @code{INFODIR}: see the sample @file{dir} in ESSDIR/ess-VERSION/doc/info. -->
<!-- If @file{dir} does not exist in @code{INFODIR}, then the sample -->
<!-- @file{dir} will be installed. -->
<!-- An alternative, if you are running XEmacs and have access to the -->
<!-- XEmacs system directories, would be to place the directory in the -->
<!-- site-lisp directory, and simply type @code{make all} (and copy the -->
<!-- documentation as appropriate). -->
<!-- For GNU Emacs, you would still have to move the files into the top level -->
<!-- site-lisp directory. -->
</ol>

<!-- >>>> FIXME (see comment in ess.texi): error in ``makeinfo readme.texi'' -->
<!-- @node Microsoft Windows installation, , Unix installation, Installation -->
<div class="node">
<p><hr>
<a name="Microsoft-Windows-installation"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Requirements">Requirements</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#Unix-installation">Unix installation</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#Installation">Installation</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.10 Microsoft Windows installation</h3>

<p>For <b>Microsoft Windows installation</b>, please follow the next steps.

     <ol type=1 start=1>

     <li><code>cd</code> to a directory where you keep emacs lisp files, or create a
new directory (for example, <samp><span class="file">c:\emacs\</span></samp>) to hold the distribution. 
This directory will be referred to below as "the ESS distribution
directory".

     <p><em>Note for XEmacs packages:</em> ESS is no longer available as an XEmacs
package. But, you can still install ESS into the XEmacs package system
by choosing <samp><span class="file">ESSDIR</span></samp>=<samp><span class="file">PREFIX\XEmacs\site-packages</span></samp>.  ESS
requires that the XEmacs sumo tarball (all XEmacs packages combined)
also be installed.  For information on installing XEmacs packages,
follow this link:
<a href="http://www.xemacs.org/Documentation/packageGuide.html">Quickstart Package Guide</a>.

     <li>Retrieve the latest zip file (<samp><span class="file">ess-VERSION.zip</span></samp>) from
<a href="http://ess.r-project.org/downloads/ess">ESS downloads area</a> and
store it in the ESS distribution directory.  Be aware that http browsers
on Windows frequently change the "." and "-" characters in filenames to
other punctuation.  Please change the names back to their original form.

     <li>Extract all the files from <samp><span class="file">ess-VERSION.zip</span></samp> into the ESS
distribution directory as <samp><span class="file">c:\emacs\ess-VERSION\</span></samp>.  (It is possible
to unpack the zip archive in Windows Explorer by double clicking on the
folder; you should then see a new folder called <samp><span class="file">ess-VERSION</span></samp>. 
Drag that folder into your ESS distribution directory.)

     <!-- @item -->
<!-- Add the line -->
<!-- @example -->
<!-- (load "C:/emacs/ess-VERSION/lisp/ess-site") -->
<!-- @end example -->
<!-- to your emacs initialization file.  (GNU Emacs uses the filename -->
<!-- @file{~/.emacs} and XEmacs uses the filename -->
<!-- @file{~/.xemacs/init.el} for the initialization file.  The tilde is -->
<!-- recognised by emacs as your HOME directory, i.e. the value of your HOME -->
<!-- environment variable.)  Replace -->
<!-- @code{VERSION} above with the version number of ESS.  Remember to use -->
<!-- forwardslashes @code{/}, rather than backslashes @code{\}, in your filename -->
<!-- inside emacs code files. -->
<li>If you are using GNU Emacs add the line
     <pre class="example">          (load "ESSDIR/ess-VERSION/lisp/ess-site")
     </pre>
     <p>to <samp><span class="file">%HOME%/.emacs</span></samp>.  For XEmacs, if you followed the XEmacs package system
installation advice, add the line
     <pre class="example">          (require 'ess-site)
     </pre>
     <p>to <samp><span class="file">%HOME%/.xemacs/init.el</span></samp>.  Otherwise, for XEmacs, add the line
     <pre class="example">          (load "ESSDIR/ess-VERSION/lisp/ess-site")
     </pre>
     <p>to <samp><span class="file">%HOME%/.xemacs/init.el</span></samp>. 
<em>Note:</em> Both GNU Emacs and XEmacs require that the HOME environment
variable be set on your system, otherwise, your initialization file will
not be utilized, and therefore, ESS will not work.

     <p>After saving your initialization file, ESS is now installed.  Start a
new emacs and you should be ready to use ESS.  For example, to edit
statistical programs, load the files with the requisite extensions
(".sas" for SAS, ".S" or "s" or "q" or "Q" for S-PLUS, ".r" or ".R" for
R, and ".lsp" for XLispStat).  One further step is needed if you wish to
run statistical processes, see below.

     <li>To run statistical processes under ESS, Windows users will need to make
sure that the directories for the software they will be using is in the
PATH environment variable.  On Windows 9x, add lines similar to the
following to your <samp><span class="file">c:\autoexec.bat</span></samp> file:
     <pre class="example">          path=%PATH%;c:\progra~1\insightful\splus70\cmd
     </pre>
     <p>On Windows NT/2000/XP, add the directories to the PATH using the
<code>My Computer/Control Panel/System/Advanced/Environment Variables</code> menu. 
Note that the directory containing the program is
added to the PATH, not the program itself.  One such line is needed
for each software program.  Be sure to use the abbreviation
<code>progra~1</code> and not the long version with embedded blanks.  Use
backslashes "<code>\</code>".

     <p>An alternative, for R users, is that rather than adjusting the PATH
variable, you can add the following to your emacs initialization file
(and restart emacs):
     <pre class="example">          (setq inferior-R-program-name "C:/progra~1/R/R-2.2.1/bin/Rterm.exe")
     </pre>
     <p>This assumes that you have installed R-2.2.1 in the default location. 
Change the path otherwise to point to other locations.

     <p>Windows users who place S-PLUS anywhere other than the default
location will also need to add the following three lines (properly
adjusted for their location) to their <samp><span class="file">%HOME%/.emacs</span></samp> or
<samp><span class="file">%HOME%/.xemacs/init.el</span></samp> file:
     <pre class="example">          (setq-default inferior-S+6-program-name
              "c:/progra~1/Insightful/SPLUS70/cmd/Splus")
          (setq-default inferior-Sqpe+6-SHOME-name
              "c:/progra~1/Insightful/SPLUS70")
          (setq-default inferior-Sqpe+6-program-name
              "c:/progra~1/Insightful/SPLUS70/cmd/Sqpe.exe")
     </pre>
     <p>The above example uses the default location of S-PLUS in
<code>c:/progra~1/Insightful</code>.  Please note that ESS
considers S-PLUS 6, 7, and 8 to be variants of S+6.

     <p>These users may also need to modify the emacs variable <code>ess-SHOME-versions</code>
to match their installation in order to get the full set of S-PLUS versions
on their machine into the <code>ESS</code> menu.

     <p>To start the S-PLUS [678].x GUI from ESS under emacs:
          <ol type=1 start=1>
<li>If you use Cygwin bash as your primary shell, then
          <pre class="example">               M-x S
               (or <code>M-x S+6</code>).
          </pre>
          <li>If you use the MSDOS prompt window as your primary shell, then
          <pre class="example">               M-x S+6-msdos
          </pre>
          </ol>
You will then be
asked for a pathname ("S starting data directory?"), from which to
start the process.  The prompt will propose your current directory
as the default.  ESS will start the S-PLUS GUI.  There will be
slight delay during which emacs is temporarily frozen.  ESS will arrange for
communication with the S-PLUS GUI using the DDE protocol. 
Send lines or regions
from the emacs buffer containing your S program (for example,
<samp><span class="file">myfile.s</span></samp>) to the S-PLUS Commands Window with the
<code>C-c C-n</code> or <code>C-c C-r</code> keys. 
(If you are still using S-PLUS 4.x or 2000,\
then use <code>M-x S+4</code> or <code>M-x S+4-msdos</code>.)

     <p>To start an S-PLUS [678].x session inside an emacs buffer&mdash;and
without the S-PLUS GUI:
     <pre class="example">          M-x Sqpe
          (or <code>M-x Sqpe+6</code>).
     </pre>
     <p>This works with both the bash and msdos shells. 
You will then be asked for a pathname ("S starting data
directory?"), from which to start the process.  The prompt will
propose your current directory as the default. 
You get Unix-like behavior, in particular the entire
transcript is available for emacs-style search commands. 
Send lines or regions from the emacs buffer containing your S
program (for example, <samp><span class="file">myfile.s</span></samp>) to the *S+6* buffer with the
<code>C-c C-n</code> or <code>C-c C-r</code> keys. 
Interactive graphics are available with Sqpe by using the java
library supplied with S-PLUS 6.1 and newer releases. 
Enter the commands:
     <pre class="example">          library(winjava)
          java.graph()
     </pre>
     <p>Graphs can be saved from the <code>java.graph</code> device
in several formats, but not PostScript.   If you
need a PostScript file you will need to open a separate
<code>postscript</code> device. 
(If you are still using S-PLUS 4.x or 2000, then use <code>M-x Sqpe+4</code>.)

     <p>To connect to an already running S-PLUS GUI (started, for example,
from the S-PLUS icon):
     <pre class="example">          M-x S+6-existing
     </pre>
     <p>or
     <pre class="example">          M-x S+6-msdos-existing
     </pre>
     <p>You will then be
asked for a pathname ("S starting data directory?"), from which to
start the process.  The prompt will propose your current directory
as the default.  ESS will arrange for
communication with the already running S-PLUS GUI using the DDE protocol. 
Send lines or regions
from the emacs buffer containing your S program (for example,
<samp><span class="file">myfile.s</span></samp>) to the S-PLUS Commands Window with the
<code>C-c C-n</code> or <code>C-c C-r</code> keys. 
(If you are still using S-PLUS 4.x or 2000,
 then use <code>M-x S+4-existing</code> or <code>M-x S+4-msdos-existing</code>.)

     <p>If you wish to run R, you can start it with:
     <pre class="example">          M-x R
     </pre>
     <p>XLispStat can not currently be run with
     <pre class="example">          M-x XLS
     </pre>
     <p>Hopefully, this will change.  However, you can still edit with
emacs, and cut and paste the results into the XLispStat
*Listener* Window under Microsoft Windows.

     <!-- SAS for Windows uses the batch access with function keys that is -->
<!-- described in -->
<!-- @file{doc/README.SAS}. -->
<!-- @xref{ESS(SAS)-MS Windows}. -->
<!-- The user can also edit SAS files -->
<!-- in an @code{ESS[SAS]} buffer and than manually copy and paste them into -->
<!-- an Editor window in the SAS Display Manager. -->
<!-- For Windows, inferior SAS in an @code{iESS{[SAS]}} buffer does not work -->
<!-- on the local machine.  It does work over a network connection to -->
<!-- SAS running on a remote Unix computer. -->
<!-- Reason:  we use ddeclient to interface with programs and SAS doesn't -->
<!-- provide the corresponding ddeserver capability. -->
<!-- @item -->
<!-- (OPTIONAL) If you are running Sqpe or R, you might consider -->
<!-- installing the database files.  From within emacs, @code{C-x d} to -->
<!-- the   directory containing ESS.  Now: -->
<!-- @example -->
<!-- M-x Sqpe+6 -->
<!-- @end example -->
<!-- to get S running.  Once you see the SPLUS prompt, do: -->
<!-- @example -->
<!-- M-x ess-create-object-name-db -->
<!-- @end example -->
<!-- (this will create the file @file{ess-s+6-namedb.el}; if it isn't in the -->
<!-- ESS directory, move it there). -->
<!-- Then, completions will be autoloaded and will not be regenerated -->
<!-- for every session. -->
<!-- For R, do the same, using -->
<!-- @example -->
<!-- M-x R -->
<!-- @end example -->
<!-- and then @code{M-x ess-create-object-name-db} creating -->
<!-- @file{ess-r-namedb.el}; if it isn't in the ESS directory, move it -->
<!-- there). -->
<li>That's it!

        </ol>
<!-- Requirements duplicated? -->
<!-- @node Requirements, , Microsoft Windows installation, Installation -->
<!-- node-name,  next,  previous,  up -->
<!-- @section Requirements -->
<!-- @include requires.texi -->

<div class="node">
<p><hr>
<a name="Reporting-Bugs"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Mailing-Lists">Mailing Lists</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#Installation">Installation</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.11 Reporting Bugs</h3>

<p>Please send bug reports, suggestions etc. to
<a href="mailto:ESS-bugs@stat.math.ethz.ch">ESS-bugs@stat.math.ethz.ch</a>

   <p>The easiest way to do this is within Emacs by typing

   <p><kbd>M-x ess-submit-bug-report</kbd>

   <p>This also gives the maintainers valuable information about your
installation which may help us to identify or even fix the bug.

   <p>If Emacs reports an error, backtraces can help us debug the problem. 
Type "M-x set-variable RET debug-on-error RET t RET".  Then run the
command that causes the error and you should see a *Backtrace* buffer
containing debug information; send us that buffer.

   <p>Note that comments, suggestions, words of praise and large cash
donations are also more than welcome.

<div class="node">
<p><hr>
<a name="Mailing-Lists"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="#Authors">Authors</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="#Reporting-Bugs">Reporting Bugs</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.12 Mailing Lists</h3>

<p>There is a mailing list for discussions and announcements relating to
ESS.  Join the list by sending an e-mail with "subscribe ess-help" (or
"help") in the body to <a href="mailto:ess-help-request@stat.math.ethz.ch">ess-help-request@stat.math.ethz.ch</a>;
contributions to the list may be mailed to
<a href="mailto:ess-help@stat.math.ethz.ch">ess-help@stat.math.ethz.ch</a>.  Rest assured, this is a fairly
low-volume mailing list.

   <p>The purposes of the mailing list include

     <ul>
<li> helping users of ESS to get along with it. 
<li> discussing aspects of using ESS on Emacs and XEmacs. 
<li> suggestions for improvements. 
<li> announcements of new releases of ESS. 
<li> posting small patches to ESS. 
</ul>

<div class="node">
<p><hr>
<a name="Authors"></a>
Previous:&nbsp;<a rel="previous" accesskey="p" href="#Mailing-Lists">Mailing Lists</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="#General-Information">General Information</a>

</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">1.13 Authors</h3>

     <ul>
<li><!-- @uref{http://www.google.com/,A.J. Rossini} -->
<a href="mailto:blindglobe@gmail.com">A.J. Rossini</a>
<!--  -->
<li><!-- @uref{http://www.sbm.temple.edu/departments/statistics/,Richard M. Heiberger} -->
<a href="mailto:rmh@temple.edu">Richard M. Heiberger</a>
<!--  -->
<li><!-- @uref{http://www.ci.tuwien.ac.at/~hornik,Kurt Hornik} -->
<a href="mailto:Kurt.Hornik@R-project.org">Kurt Hornik</a>
<!--  -->
<li><!-- @uref{http://stat.ethz.ch/people/maechler/,Martin Maechler} -->
<a href="mailto:maechler@stat.math.ethz.ch">Martin Maechler</a>
<!--  -->
<li><!-- @uref{http://www.mcw.edu/pcor/rsparapa,Rodney A. Sparapani} -->
<a href="mailto:rsparapa@mcw.edu">Rodney A. Sparapani</a>
<!--  -->
<li><!-- @uref{http://www.damtp.cam.ac.uk/user/eglen,Stephen Eglen} -->
<a href="mailto:stephen@gnu.org">Stephen Eglen</a>
</ul>

   <div class="footnote">
<hr>
<a name="texinfo-footnotes-in-document"></a><h4>Footnotes</h4><p class="footnote"><small>[<a name="fn-1" href="#fnd-1">1</a>]</small> 
require the files.el patch to revert-buffer for the Local Variables
updating problem</p>

   <p><hr></div>

</body></html>

